#!/usr/bin/env python

# Mike_License_Plate Rel 1
# Created by Tin Tran http://bakon.ca/gimplearn/
# Comments directed to http://gimpchat.com or http://gimpscripts.com
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html
#
#
# ------------
#| Change Log |
# ------------
# Rel 1: Initial release.
import math
import string
#import Image
from gimpfu import *
from array import array

def python_mike_license_plate(image, layer, backgroundcolor, platecolor1, platecolor2, licensetextcolor,statetextcolor,licensetext,statetext,licensetextfont,statetextfont,flattenimage) :
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	
	#pdb.gimp_message("This is sample shell script.")
	#PUT YOUR CODE HERE 
	
	#creates new image and attach it to a display
	new_image = pdb.gimp_image_new(550,300,RGB)
	new_display = pdb.gimp_display_new(new_image)
	
	#use background color as background fill
	carlayer = pdb.gimp_layer_new(new_image,550,300,RGBA_IMAGE,"Car background",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(new_image,carlayer,None,-1)
	pdb.gimp_context_set_foreground(backgroundcolor)
	pdb.gimp_drawable_fill(carlayer,FOREGROUND_FILL)
	
	#create plate layer
	platelayer = pdb.gimp_layer_new(new_image,550,300,RGBA_IMAGE,"Plate",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(new_image,platelayer,None,-1)
	
	#select rounded rectangle
	pdb.gimp_image_select_rectangle(new_image,CHANNEL_OP_REPLACE,25,25,500,250)
	pdb.script_fu_selection_rounded_rectangle(new_image,platelayer,20.0,0)
	
	#gradient fill plate
	#pdb.gimp_context_set_gradient("FG to BG (RGB)")
	pdb.gimp_context_set_foreground(platecolor1)
	pdb.gimp_context_set_background(platecolor2)
	pdb.gimp_edit_blend(platelayer,FG_BG_RGB_MODE,NORMAL_MODE,GRADIENT_LINEAR,100,0,REPEAT_NONE,0,0,3,0.2,1,25,25,525,275)
	pdb.gimp_selection_none(new_image)
	
	#HSV noise
	pdb.plug_in_hsv_noise(new_image,platelayer,2,10,0.05,0.05)
	pdb.python_layer_fx_drop_shadow(new_image,platelayer,(0,0,0),20,0,0,MULTIPLY_MODE,0,3,130,2,1,0)
	
	#bevel layer
	bevellayer = pdb.gimp_layer_new(new_image,550,300,RGBA_IMAGE,"Bevel",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(new_image,bevellayer,None,-1)
	
	pdb.gimp_image_select_item(new_image,CHANNEL_OP_REPLACE,platelayer)
	pdb.gimp_selection_shrink(new_image,5)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(bevellayer,FOREGROUND_FILL)
	pdb.gimp_selection_shrink(new_image,10)
	pdb.gimp_edit_clear(bevellayer)
	pdb.gimp_selection_none(new_image)
	pdb.gimp_layer_set_opacity(bevellayer,0)
	
	pdb.python_layer_fx_outer_glow(new_image,bevellayer,(0,0,0),10,6,0,NORMAL_MODE,0,5,0,0)
	pdb.python_layer_fx_bevel_emboss(new_image,bevellayer,1,35,0,8,2,130,15,6,(255,255,255),NORMAL_MODE,40,(0,0,0),MULTIPLY_MODE,5,6,0,"Blue Squares",1,100,0,0)
	
	#cut away around the plate highlight layer so it doesn't highlight the car color too.
	bevelhighlightlayer = pdb.gimp_image_get_layer_by_name(new_image,"Bevel-highlight")
	pdb.gimp_image_select_item(new_image,CHANNEL_OP_REPLACE,platelayer)
	pdb.gimp_selection_invert(new_image)
	pdb.gimp_edit_clear(bevelhighlightlayer)
	
	
	pdb.gimp_selection_none(new_image)
	pdb.gimp_image_set_active_layer(new_image,bevelhighlightlayer)
	
	#Text layer
	pdb.gimp_context_set_foreground(licensetextcolor)
	licensetextlayer = pdb.gimp_text_layer_new(new_image,licensetext,licensetextfont,250,0)
	pdb.gimp_image_insert_layer(new_image,licensetextlayer,None,-1)
	pdb.plug_in_autocrop_layer(new_image,licensetextlayer)
	pdb.gimp_layer_scale(licensetextlayer,400,115,0)
	pdb.gimp_layer_set_offsets(licensetextlayer,75,95)
	
	#Text Bevel layer
	textbevellayer = pdb.gimp_layer_new(new_image,550,300,RGBA_IMAGE,"Text Bevel",100,NORMAL_MODE)
	pdb.gimp_image_insert_layer(new_image,textbevellayer,None,-1)
	pdb.gimp_image_lower_item(new_image,textbevellayer)
	
	#fill text bevel and set opacity to zero
	pdb.gimp_image_select_item(new_image,CHANNEL_OP_REPLACE,licensetextlayer)
	pdb.gimp_selection_grow(new_image,5)
	pdb.gimp_context_set_foreground((0,0,0))
	pdb.gimp_edit_fill(textbevellayer,FOREGROUND_FILL)
	pdb.gimp_layer_set_opacity(textbevellayer,0)
	
	#bevel emboss then invert selection and cut away so we're left with just bevel text.
	pdb.python_layer_fx_bevel_emboss(new_image,textbevellayer,1,35,0,8,2,130,15,6,(255,255,255),NORMAL_MODE,100,(0,0,0),MULTIPLY_MODE,10,6,0,"Blue Squares",1,100,0,0)
	textbevelhighlightlayer = pdb.gimp_image_get_layer_by_name(new_image,"Text Bevel-highlight")
	pdb.gimp_selection_invert(new_image)
	pdb.gimp_edit_clear(textbevelhighlightlayer)
	
	pdb.gimp_selection_none(new_image)
	
	#State Text layer
	pdb.gimp_context_set_foreground(statetextcolor)
	statetextlayer = pdb.gimp_text_layer_new(new_image,statetext,statetextfont,250,0)
	pdb.gimp_image_insert_layer(new_image,statetextlayer,None,-1)
	pdb.plug_in_autocrop_layer(new_image,statetextlayer)
	
	pdb.gimp_layer_scale(statetextlayer,float(statetextlayer.width)/statetextlayer.height*32,32,0)
	pdb.gimp_layer_set_offsets(statetextlayer,float(new_image.width)/2-float(statetextlayer.width)/2,50)
	
	if flattenimage == 1:
		pdb.gimp_image_flatten(new_image)
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_mike_license_plate",                           
	"Creates a License Plate",
	"Creates a License Plate...",
	"Tin Tran",
	"Tin Tran",
	"2014",
	"<Image>/Python-Fu/Create New/Mike License Plate...",             #Menu path
	"", 
	[
	(PF_COLOR, "backgroundcolor",  "Background/Car Color:",  (255,255,255)),
	(PF_COLOR, "platecolor1",  "Plate Color 1 (Light gradient):",  (233,233,233)),
	(PF_COLOR, "platecolor2",  "Plate Color 2 (Dark gradient):",  (210,210,210)),
	(PF_COLOR, "licensetextcolor",  "License Text Color:",  (34,31,112)),
	(PF_COLOR, "statetextcolor",  "State Text Color:",  (192,41,34)),
	(PF_STRING, "licensetext", "License Text:", "GLF-061"),
	(PF_STRING, "statetext", "State Text:", "California"),
	(PF_FONT, "licensetextfont", "License Text Font:", "Sans"),
	(PF_FONT, "statetextfont", "State Text Font:", "Sans"),
	(PF_TOGGLE, "flattenimage",   "Flatten Image:", 1),
	],
	[],
	python_mike_license_plate)

main()
